%                                 SIMULATION NANOSATELLITE MISSION CASAA
%                                 **************************************

% clear

disp('');
disp('******************************************************************');
disp('');
disp('    Ce programme contient les caracteristiques inertielles')
disp('                et orbitales du satellite');
disp('  Il demande aussi les donnes du scao en dsaturation');
disp('');disp('');

disp('    POUR LES MODIFIER EDITEZ scaodat9.m sous un editeur quelconque');
disp('');disp('');disp('');

casesen on;
% Elements de la matrice d'inertie du satellite

Ir=0.032;
It=0.036;
Il=0.022;

% Caractristiques de l'orbite du satellite

altitude_orbite=817;		% altitude satellite en km
rayon_orbital=(6378+altitude_orbite)*1000;
vitesse_rotation=sqrt(39.86e13/rayon_orbital^3);
				% pulsation orbitale en rd/s
inclinaison=98.7*pi/180;



disp('******************************************************************');

% Reprsentation d'tat du SCAO non perturb

Asat=[0 1 0 0 0 0;
   -4*(It-Il)*vitesse_rotation^2/Ir...
          0 0 0 0 -(Ir+Il-It)*vitesse_rotation/Ir;
   0 0 0 1 0 0;
   0 0 -3*(Ir-Il)*vitesse_rotation^2/It 0 0 0;
   0 0 0 0 0 1;
   0 (Ir+Il-It)*vitesse_rotation/Il...
          0 0 -(It-Ir)*vitesse_rotation^2/Il 0];

Bsat=[0 0 0;
   1/Ir 0 0;
   0 0 0;
   0 1/It 0;
   0 0 0;
   0 0 1/Il];


disp('*****************************************************************************************');

% tsim=input('          Temps de simulation (s) : ');

tsim=1000;

disp('');
disp('***********************************************************');
disp('');
disp('   On vous demande le nombre de points de memorisation  de Matlab ');
disp('      ceci pour le trace des courbes des variables de sortie');
disp('');

% points_trace=input('    Nombre points memorisation trace des courbes : ');

points_trace=2000;


% disp('');

 %                SIMULATION DE DESATURATION AVEC COMMANDE P & D DE LA ROUE 

 disp('***************** DONNEES DU SCAO DE simclas9.m et nanoPID9.m ********************');
  
 disp('***************** DONNEES SATELLITE EN TANGAGE SEUL********************');

 disp('   teta_zero,teta_prim0,consigne_tangage,retard1,retard2 ');

 teta_zero=5*pi/180; % Position initiale en radian

 teta_prim0=0; % vitesse initiale en rd/s
 
 consigne_tangage=0.1;  %   Valeur de consigne de l'angle de tangage  atteindre, en radian 
 
 retard1=0.5;        %   Retard en secondes de la mesure de la position

 retard2=0.2;        %   Retard en secondes de la mesure de la vitesse


disp('***************** DONNEES ROUE********************');

  disp('   K_PD,F_PD,retard3,rotation_initiale,rotation_maximale,J,gain_desaturation');
  disp('   Ti,Td,N');

 K_PD=43e-5;        % Gain du rappel proportionnel de la roue
 
 F_PD=15e-4;       % Gain de l'amortissement PD de la roue

 Ti=1e-3;            % Constante de temps de l'intgrateur

 Td =2;           % Constante de temps de chane drive

 N=6;             % Entier ou pas  choisir entre 3 et 10 classiquement

 retard3=1;       % Retard de raction de la roue

 rotation_initiale= 65*2*pi;    % Vitesse de rotation initiale de la roue  3900 t/mn

 rotation_maximale= 60*2*pi;% Vitesse de rotation maximale de la roue 3600 t/mn

 J=3.2e-5;        % Inertie axiale de la roue$

 disp('***************** DONNEES PID********************');
 
 K_PID=47.3e-5;  %   Gain proportionnel
 F_PID=30e-4;  %   Gain amortissement drive
 I_PID=1e-6;     %   Gain intgrateur

 disp('***************** DONNEES DESATURATION********************');

  disp('   desature_on, desat_en_cours');

  desature_on=0;  % initialisation de la squence de dsaturation ( 0=pas de dsaturation, 1=dsaturation)
  desat_en_cours=0;

  disp('   J:/_AA_nano/desature.mat   contient l''initialisation de la dsaturation ');

  save J:/_AA_nano/desature.mat desature_on,desat_en_cours;  % Mise en mmoire de l'initialisation

  %  Ces valeurs seront retrouves par le programme desature.m qui chargera ces valeurs changeantes

 disp('***************** DONNEES MAGNETIQUES********************');

 disp('   gain_desaturation');

 gain_desaturation = 8e3;   % Gain de la desaturation  appliquer aux bobines roulis et lacet

 disp('********************** FIN DES DONNEES********************');

 disp('--------------LANCER DANS L''ESPACE MATLAB --------------------');
 disp('              simclas9.m      ');